//==========================================================================
//     Austausch von m Vektoren aus n Vektoren
// Rueckkehrcode: Anzahl der ausgetauschten Vektoren.
//==========================================================================
#include "ls.h"
int ls_austausch(int m,     //  Anzahl der auszutauschenden Vektoren
                 int n,     //  Anzahl der Quell-Vektoren
                 REAL *A,   //  zweidimensionales Feld,
                            //  I: zeilenweise die Linearfaktoren
                            //  O: zeilenweise die neuen Linearfaktoren
                 int **iw,  //  Hilfsfeld (oder NULL)
                            //  O: im Falle j=iw[i]<=0 ist der i-te Vektor
                            //     gegen den -j-ten ausgetauscht worden;
                            //     andernfalls erfolgte wegen linearer
                            //     Abhaengigkeit kein Austausch
                 int **jv)  //  Hilfsfeld (oder NULL)
                            //  O: im Falle i=jv[j]<=0 ist der -i-te Vektor
                            //     gegen den j-ten ausgetauscht worden
{ REAL epsaustausch=1.e-10,t,piv,klein=epsaustausch,*a,*aa,*ae=A+m*n;
  int i,js,rc=0,j,*iww=*iw,*jvv=*jv;
  if(!iww) *iw=iww=new int[n];if(!jvv) *jv=jvv=new int[n];
  for(j=0;j<n;jvv[j++]=j);
  for(i=0,a=A;a<ae;a+=n,i++)
  { piv=klein;            // Pivotisierung
    for(j=0;j<n;j++)
    { t=fabs(a[j]);if((jvv[j]>0)&&(piv<t-epsaustausch)) piv=t,js=j;}
    if(piv==klein){ iww[i]=i+1;continue;}else klein=piv*epsaustausch;
    iww[i]=-js,jvv[js]=-i,piv=1/a[js],a[js]=1;     // Transformation
    for(aa=A+js;aa<ae;*aa*=piv,aa+=n);
    for(j=0;j<n;j++)
    { t=a[j];if((j==js)||(fabs(t)<klein)) continue;
      a[j]=0;for(aa=A;aa<ae;aa[j]-=aa[js]*t,aa+=n);}
    rc++;
  }
  return(rc);
}
