//==========================================================================
//    Transformation einer Matrix auf Halbdiagonalform mit Spalten-Auswahl
// Rueckkehrcode: Zeilenrang der Matrix.
//==========================================================================
#include "ls.h"
int ls_gauss(int m,      // Zeilenanzahl
             int n,      // Spaltenanzahl
             int nn,     // Anzahl der ersten Spalten, die in die Auswahl
                         // einbezogen werden sollen
             REAL *A,    // zu transformierende (m,n)-Matrix
                         // O: transformierte Matrix
             int **inds) // n-dimen. Hilfsfeld (oder NULL)
                         // O: Spaltenreihenfolge
{ int i,j,js,rc=0,*ind=*inds;
  REAL epsgauss=1.e-10,piv,t,klein=epsgauss,*scal,*a,*aa,*ae=A+m*n;
  scal=new REAL[n];if(!ind) ind=*inds=new int[n];
  for(i=0,a=A;i<nn;scal[i++]=t,a+=n)
    for(t=0,j=0;j<n;t+=fabs(a[j++]));
  for(j=0;j<n;ind[j++]=j);
  for(i=0,a=A;a<ae;i++,a+=n)
  { piv=klein=epsgauss;                      // Spalten-Auswahl
    for(j=i;j<nn;j++){ t=fabs(a[ind[j]])*scal[j];
    if(piv<t-klein) piv=t,js=j;}
    if(piv==klein){ rc++;continue;}else klein=piv*epsgauss;
    j=ind[js],ind[js]=ind[i],ind[i]=js=j,piv=1/a[js];// Transformation
    for(aa=a+n;aa<ae;aa+=n)
    { t=aa[js]*=piv;if(fabs(t)<klein){ aa[js]=0;continue;}
      for(j=i;++j<n;aa[ind[j]]-=a[ind[j]]*t);}
  }
  delete [] scal;return(m-rc);
}
