//==========================================================================
//     LDLT-Faktorisierung einer symmetrischen, positiv definiten Matrix
// Rueckkehrcode: -1, falls die Matrix nicht positiv definit ist; sonst 0.
//==========================================================================
#include "ls.h"
int ls_ldlt(int n,       // Dimension der Matrix
            int d,       // hoechster Index einer Nebendiagonalen,
                         // (Hauptdiagonale hat den Index 0)
            REAL *A,     // Matrix (oberes Dreieck wird benutzt)
                         // O: auf dem unteren Dreieck steht die Matrix L
            REAL **diag) // n-dimensionales Hilfsfeld
                         // O: Diagonalelemente der Diagonalmatrix D
{ int i,j,k,ne,na;REAL s,t,epsldlt=1.e-10,*a,*aa,*dia=*diag;
  if(!dia) dia=*diag=new REAL[n];
  for(i=0,a=A;i<n;i++,a+=n)
  { na=(i-d<1)?0:i-d-1;
    for(j=i,s=0;j-->na;s+=dia[j]*a[j]*a[j]);
    if((a[i]<s)||(ausl(a[i],s)<epsldlt)) return(-1);
    dia[i]=t=a[i]-s,t=1/t;ne=(n<i+d+1)?n:i+d+1;
    for(j=i,aa=a+n;++j<ne;aa+=n)
    { for(k=i,s=0;k-->na;s+=dia[k]*a[k]*aa[k]);
      aa[i]=(ausl(a[j],s)<epsldlt)?0:(a[j]-s)*t;}
  }
  return(0);
}
