//==========================================================================
//     LU-Faktorisierung einer quadratischen Matrix mit Spalten-Auswahl
// Rueckkehrcode: Rangdefekt.
//==========================================================================
#include "ls.h"
int ls_lu(int n,      // Dimension der Matrix
          REAL *A,    // (n,n)-Matrix
                      // O: im unteren Dreieck befindet sich die untere,
                      //    im oberen Dreieck die obere Dreiecksmatrix
          int **inds) // Hilfsfeld (oder NULL)
                      // O: Spaltenreihenfolge
{ int i,j,js,rc=0,*ind=*inds;
  REAL epslu=1.e-10,piv,s,e=epslu,*scal,*a,*ai,*ae=A+n*n;
  scal=new REAL[n];if(!ind) ind=*inds=new int[n];
  for(i=0,a=A;i<n;scal[i++]=s,a+=n)
    for(s=0,j=0;j<n;s+=fabs(a[j++]));
  for(j=0;j<n;ind[j++]=j);
  for(i=0,a=A;i<n;i++,a+=n)
  { piv=e=epslu;                              // Spalten-Auswahl
    for(j=i;j<n;j++){ s=fabs(a[ind[j]])*scal[j];if(piv<s-e) piv=s,js=j;}
    if(piv==e){ rc++;continue;}else e=piv*epslu;
    j=ind[js],ind[js]=ind[i],ind[i]=js=j, // Spaltentausch
    piv=1/a[js];                              // Transformation
    for(ai=a+n;ai<ae;ai+=n)
    { s=ai[js]*=piv;if(fabs(s)<e){ ai[js]=0;continue;}
      for(j=i;++j<n;ai[ind[j]]-=a[ind[j]]*s);}
  }
  delete [] scal;return(n-rc);
}
