//==========================================================================
//      Loesen eines Gleichungssystems bei vorliegender LU-Faktorisierung
//==========================================================================
#include "ls.h"
void ls_lu_solve(int n,      // Dimension der Matrix
                 REAL *LU,   // LU-Faktoren einer regulaeren Matrix;
                             // auf dem unteren Dreieck steht die Matrix L,
                             // auf dem oberen die Matrix U
                 int *inds,  // Spaltenreihenfolge
                 REAL *b,    // rechte Seite des Gleichungssystems
                 REAL **x)   // n-dimensionales Hilfsfeld (oder NULL)
{ int i,j;REAL t,*a,*xx=*x;
  if(!xx) xx=*x=new REAL[n];
  for(i=0,a=LU;i<n;xx[inds[i]]=b[i]-t,i++,a+=n)
    for(j=0,t=0;j<i;t+=a[inds[j]]*xx[inds[j]],j++);
  for(i=n,a=LU+n*n-n;i-->0;xx[inds[i]]=(xx[inds[i]]-t)/a[inds[i]],a-=n)
    for(j=i,t=0;++j<n;t+=a[inds[j]]*xx[inds[j]]);
}
