//==========================================================================
//      Nachiteration beim Loesen eines linearen Gleichungssystems
// Rueckkehrcode: Anzahl der ausgefuehrten Nachiterationen.
//==========================================================================
#include "ls.h"
REAL ausl(REAL,REAL);void ls_lu_solve(int,REAL *,int *,REAL *,REAL*);
int ls_nachiter(int n,      // Dimension der Matrix
                REAL *A,    // Koeffizientenmatrix
                REAL *b,    // rechte Seite des Gleichungssystems
                REAL *x,    // aktuelle Loesung
                            // O: nachiterierte Loesung
                REAL *LU,   // LU-Faktoren von A; auf dem unteren Dreieck
                            // steht L, auf dem oberen die Matrix U
                int *inds,  // Spaltenreihenfolge in LU
                int iter)   // maximale Anzahl von Nachiterationen
{ int i,j,it=iter;REAL epsnachiteration=1.e-10,*r,t,*y,*a,klein;
  long double s;
  r=new REAL[n+n],y=r+n;
  while(iter&&klein>epsnachiteration)
  { klein=epsnachiteration,iter--;
    for(a=A,i=0;i<n;r[i++]=b[i]-s,a+=n)
      for(j=0,s=0;j<n;s+=(long double)(a[j]*x[j]),j++);
    ls_lu_solve(n,LU,inds,r,y);
    for(i=0;i<n;i++)
      t=x[i]-y[i],s=ausl(t,x[i]),klein=(s>klein)?s:klein,x[i]=t;}
  delete [] r;return(it-iter);
}
