//==========================================================================
//      Loesen eines Gleichungssystems
//      bei vorliegender QR-Faktorisierung
//==========================================================================
#include "ls.h"
void ls_qr_solve(int n,      // Spaltenzahl
                 REAL *A,    // Matrix, die die QR-Faktorisierung enthaelt
                             // (mit Programm ls_qr erzeugt)
                 REAL *diag, // Hauptdiagonalelemente des oberen Dreiecks R
                 REAL *q,    // u-Faktoren der orthogonalen Matrix Q
                 REAL *b)    // rechte Seite
                             // O: Loesungsvektor
{ int k,i;
  REAL *a=A,*ae=A+n*n,*ak,s;
  for(k=0;k<n;k++,a+=n)
  { for(i=k,ak=a+k,s=0;ak<ae;s+=b[i++]*(*ak),ak+=n);
    for(i=k,s=s*q[k],ak=a+k;ak<ae;b[i++]-=(*ak)*s,ak+=n);}
  for(k=n,a=ae-n;k-->0;b[k]=(b[k]-s)/diag[k],a-=n)
    for(i=k,s=0;++i<n;s+=b[i]*a[i]);
}
