//=========================================================================
//            Funktionen der Klasse ls_Vector
//=========================================================================
#ifndef sp_h
#include "sp.h"
#endif
ls_Vector::ls_Vector (Int nn, char *onam):ls_Org(onam)
{ static char *q1 = "Vector::ls_Vector";
  n = nn;
  if (!n){ A = NULL; return;}
  if (!(A = new Real[n])) sp_error_(q1);
  memset(A, 0, sizeof(Real) * n);
}

ls_Vector::~ls_Vector ()
{ if (!*copy && !n) delete [] A; }

void ls_Vector::write(ostream &f)
{ static char *q1 = "Vector::write";
  Int i, prec = asp-9;

  f.unsetf(ios::scientific), f.unsetf(ios::floatfield);

  if (oname) f << oname << endl;
  f << "{ ls_Vector " << n << endl;
  for (i = 0; i < n; f <<setw(asp)<<setprecision(prec)<<A[i++]);
  f << endl << "}" << endl;
}

void ls_Vector::read(istream &f)
{ static char *q1 = "Vector::read";
  char w[32];
  Int nn;
  Real *x = A, *xe = x+n;

  if (oname)
  { while (f >> w && strcmp(oname, w));
    if (!f.good()) sp_error_(q1, 3);
  }
  
  if (!(f >> w) || (*w != '{')) sp_error_(q1, 3);
  if (!(f >> w) || strcmp(w, "Vector")) sp_error_(q1, 5);
  if (!(f >> nn) || (n != nn)) sp_error_(q1, 6);
  for (; x < xe; f >> *x, x++);
  if (!(f >> w) || (*w != '}')) sp_error_(q1, 4);
}

void ls_Vector::operator>>(char *name)
{ if (*name == '\0') write(cout);
  else{ ofstream f(name); write(f);}
}

void ls_Vector::operator<<(char *name)
{ if (*name == '\0') read(cin);
  else{ ifstream f(name); read(f);}
}

Real& ls_Vector::operator[] (Int  k)            // Komponenten-Ein/Ausgabe
{ static char *q1 = "Vector::operator[]";
  if (k > n) sp_error_(q1, 7);
  return *(A+k-1);
}

Int ls_Vector::operator== (const ls_Vector &u) const
{
#ifdef sp_test
  static char *q1 = "Vector::operator==";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Real *uu = u.A, *x = A, *xe = x+n;

  for (; x < xe; x++, uu++)
    if (ausl(*x, -*uu) > eps) return 0;
  return 1;
}

Int ls_Vector::operator!= (const ls_Vector &u) const
{
#ifdef sp_test
  static char *q1 = "Vector::operator!=";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Real *uu = u.A, *x = A, *xe = x+n;

  for (; x < xe; x++, uu++)
    if (ausl(*x, -*uu) > eps) return 1;
  return 0;
}

ls_Vector ls_Vector::operator- () const
{ ls_Vector yy(n);
  Real *y = yy.A, *ye = y+n, *x = A;

  for (; y < ye; *y = -*x, y++, x++);
  return yy;
}

ls_Vector ls_Vector::operator= (Real a)
{ Real *y = A, *ye = A+n;

  for (; y < ye; *y = a, y++);
  return *this;
}

ls_Vector ls_Vector::operator* (Real a) const
{ ls_Vector yy(n);
  Real *y = yy.A, *ye = y+n, *x = A;

  for (; y < ye; *y = *x + a, y++, x++);
  return yy;
}

void ls_Vector::operator= (const ls_Vector &u)
{
#ifdef sp_test
  static char *q1 = "Vector::operator=";
  if (u.n != n) sp_error_(q1, 6);
#endif
  memcpy(A, u.A, sizeof(Real) * n);
}

ls_Vector ls_Vector::operator= (const sp_Vector &u)
{
#ifdef sp_test
  static char *q1 = "Vector::operator=";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Vec_el *uu, *ue;
  memset(A,0,sizeof(Real) * n);

  for (uu = u.A, ue = u.A+u.n_A; uu < ue; A[uu->i] = uu->x, uu++);
  return *this;
}

ls_Vector ls_Vector::operator+ (const ls_Vector &u) const
{
#ifdef sp_test
  static char *q1 = "Vector::operator+";
  if (u.n != n) sp_error_(q1, 6);
#endif
  ls_Vector yy(n); yy = *this;
  Real *y = yy.A, *uu = u.A;

  for (Int i = 0; i < n; y[i++] += uu[i]);
  return yy;
}

ls_Vector ls_Vector::operator- (const ls_Vector &u) const
{
#ifdef sp_test
  static char *q1 = "Vector::operator-";
  if (u.n != n) sp_error_(q1, 6);
#endif
  ls_Vector yy(n); yy = *this;
  Real *uu = u.A, *y = yy.A;

  for (Int i = 0; i < n; y[i++] -= uu[i]);
  return yy;
}

ls_Vector ls_Vector::operator+= (const ls_Vector &u)
{
#ifdef sp_test
  static char *q1 = "Vector::operator+=";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Real *uu = u.A;

  for (Int i = 0; i < n; A[i++] += uu[i]);
  return *this;
}

ls_Vector ls_Vector::operator-= (const ls_Vector &u)
{
#ifdef sp_test
  static char *q1 = "Vector::operator-=";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Real *uu = u.A;

  for (Int i = 0; i < n; A[i++] -= uu[i]);
  return *this;
}

Real ls_Vector::operator* (const ls_Vector &u) const// Skalarprodukt
{
#ifdef sp_test
  static char *q1 = "Vector::operator*";
  if (u.n != n) sp_error_(q1, 6);
#endif
  Real *uu = u.A, s, sp = 0, sm = 0;

  for (Int i = 0; i < n; i++)
  { if ((s = uu[i] * A[i]) > 0) sp += s; else sm += s; }
  if (ausl(sp, -sm) < eps) return 0.; else return sp + sm;
}

ls_Vector ls_Vector::operator*= (Real a)
{ for (Int i = 0; i < n; A[i++] *= a);
  return *this;
}


