//=========================================================================
//            Funktionen der Klasse sp_sMatrix
//=========================================================================
#ifndef sp_h
#include "sp.h"
#endif
sp_sMatrix::sp_sMatrix(Int nn, char *meth, char *onam):sp_Matrix(0,0,meth,onam)
{ static char *q1 = "sp_Matrix::sp_Matrix";
  Int i;
  m = n = nn, l_A = 0, a_name = u_name = NULL, a_n = u_n = 0;
  if (!n) return;

  for (i = 0, typ = sp_END; sp_s_mask[i] != sp_END; i++)
    if (!strcmp(meth, sp_meth[sp_s_mask[i]])){ typ = sp_s_mask[i]; break;}

  switch(typ)
  { case sp_MAT:
    case sp_LDLT:
    case sp_LDLTinc:
      icol = NULL,
      sp_zero_(&A, &l_A, m, n);
      typ <<= 4;
      break;
    case sp_LDLTpiv:
      if (!(icol = new Int[n+1])) sp_error_(q1);
      sp_zero_(&A, &l_A, m, n);
      typ <<= 4;
      break;
    case sp_END:
      sp_error_(q1,26);
  }
}

sp_sMatrix::~sp_sMatrix()
{ if (!*copy && n)
  { switch(typ>>4)
    { case sp_MAT:
      case sp_LDLT:
        delete []A;
        break;
      case sp_LDLTinc:
        if (a_name && !a_n){ remove(a_name); delete [] a_name;}
        if (u_name && !u_n){ remove(u_name); delete [] u_name;;}
        delete []A;
        break;
      case sp_LDLTpiv:
        delete []A;
        delete []icol;
        break;
    }
    typ = (sp_END<<4);
  }
}

void sp_sMatrix::write(ostream &f)
{ static char *q1 = "sp_sMatrix::write";
  Int i, prec = asp-9;
  NNE *iz;

  f.unsetf(ios::scientific), f.unsetf(ios::floatfield);

  if (oname) f << oname << endl;
  f << "{ sp_sMatrix " << n;

  switch (typ&15)
  { case sp_MAT:
      f << " " << sp_meth[typ&15] << endl;
      for (i = 1; i <= n; i++)
      { f <<"Row "<<i<<" "<<(A+i)->i<<" "<<(A+i)->j<<endl;
        iz = A+i;
        while ((iz = iz->z) != A)
          f << setw(10) << iz->j\
            << setw(asp) << setprecision(prec) << iz->x << endl;
      }
      break;
    case sp_LDLT:
      f << " " << sp_meth[typ&15] << endl;
      for (i = 1; i <= n; i++)
      { f <<"Row "<<i<<" "<<(A+i)->i<<" "<<(A+i)->j<<endl;
        iz = A+i;
        while ((iz = iz->z) != A)
        f << setw(10) << iz->j\
          << setw(asp) << setprecision(prec) << iz->x << endl;
      }
      break;
    case sp_LDLTpiv:
      f << " " << sp_meth[typ&15] << endl;
      for (i = 1; i <= n; i++)
        f << " " << icol[i]; cout << endl;
      for (i = 1; i <= n; i++)
      { f <<"Row "<<i<<" "<<(A+i)->i<<" "<<(A+i)->j<< endl;
        iz = A+i;
        while ((iz = iz->z) != A)
          f << setw(10) << iz->j\
            << setw(asp) << setprecision(prec) << iz->x << endl;
      }
      break;
    case sp_LDLTinc:
      if (u_n) f << " " << sp_meth[sp_MAT] << endl;
      else  f << " " << sp_meth[typ&15] << endl;
      for (i = 1; i <= n; i++)
      { f <<"Row "<<i<<" "<<(A+i)->i<<" "<<(A+i)->j<< endl;
        iz = A+i;
        while ((iz = iz->z) != A)
          f << setw(10) << iz->j\
            << setw(asp) << setprecision(prec) << iz->x << endl;
      }
      if (!u_n)
      { ifstream fu(u_name, ios::in|ios::binary);
        if (!fu) sp_error_(q1, 8);
        NNE *a;
        Int lm = sizeof(NNE)*(More+1), lmm = sizeof(NNE)*(n+1);
        for(a=A,fu.read((char *)a,lmm);a=a->s;fu.read((char *)a,lm));
        for (i = 1; i <= m; cout << endl, i++)
        { iz = A+i;
          while ((iz = iz->z) != A)
            f << setw(asp) << setprecision(prec) << iz->x;
        }
        ifstream fa(a_name, ios::in|ios::binary);
        if (!fa) sp_error_(q1, 8);
        for(a=A,fa.read((char *)a,lmm);a=a->s;fa.read((char *)a,lm));
      }
      break;
  }
  f << "}" << endl;
}

void sp_sMatrix::read(istream &f)
{ static char *q1 = "sp_sMatrix::read";
  char w[32];
  Mat_el u;
  Int nn, ll, i, k;
  unsigned char atyp;

  if (oname)
  { while (f >> w && strcmp(w, oname));
    if (!f.good()) sp_error_(q1, 9);
  }
  if (!(f >> w) || (*w != '{')) sp_error_(q1, 9);
  if (!(f >> w) || strcmp (w, "sp_sMatrix")) sp_error_(q1, 10);
  if (!(f >> nn) || (n != nn)) sp_error_(q1, 12);
  if (!(f >> w)) sp_error_(q1, 10);
   for (i = 0, atyp = sp_END; sp_s_mask[i] != sp_END; i++)
    if (!strcmp(w,sp_meth[sp_s_mask[i]])){ atyp=sp_s_mask[i]; break;}

  switch(atyp)
  { case sp_MAT:
    case sp_LDLT:
      if ((typ&15) != atyp) sp_error_(q1, 26);
      for (k = 1; k <= n; k++)
      { if ((A+k)->i) sp_error_(q1, 27);
        f >> w;
        if (strcmp(w, "Row")) sp_error_(q1, 11);
        f >> i;
        if (i != k) sp_error_(q1, 15);
        f >> (A+i)->i, f >> (A+i)->j, u.i=i, ll = (A+i)->i;
        while (ll--) f >> u.j, f >> u.x, *this << u;
      }
      typ |= atyp;
      break;
    case sp_LDLTpiv:
      if (atyp != (typ>>4)) sp_error_(q1, 26);
      for (i = 1; i <= n; f >> icol[i++]);
      for (k = 1; k <= n; k++)
      { if ((A+k)->i) sp_error_(q1, 27);
        f >> w;
        if (strcmp(w, "Row")) sp_error_(q1, 11);
        f >> i;
        if (i != k) sp_error_(q1, 15);
        f >> (A+i)->i, f >> (A+i)->j, u.i=i, ll = (A+i)->i;
        while (ll--) f >> u.j, f >> u.x, *this << u;
      }
      typ |= sp_LDLTpiv;
      break;
    case sp_LDLTinc:
      if (!(((typ>>4) == atyp)||((typ>>4) == sp_MAT))) sp_error_(q1,26);
      for (k = 1; k <= n; k++)
      { if ((A+k)->i) sp_error_(q1, 27);
        f >> w;
        if (strcmp(w, "Row")) sp_error_(q1, 11);
        f >> i;
        if (i != k) sp_error_(q1, 15);
        f >> (A+i)->i, f >> (A+i)->j, u.i=i, ll = (A+i)->i;
        while (ll--) f >> u.j, f >> u.x, *this << u;
      }
      if ((typ>>4)!= atyp) break;
      if (!a_name)
        a_name = new char [L_tmpnam], tmpnam(a_name),
        u_name = new char [L_tmpnam], tmpnam(u_name);
      { NNE *a, *iz;
        Int lm = sizeof(NNE)*(More+1), lmm = sizeof(NNE)*(n+1);
        ofstream fa(a_name, ios::out|ios::binary);
        if (!fa) sp_error_(q1, 8);
        for (a=A,fa.write((char *)a,lmm);a=a->s;fa.write((char *)a,lm));
        fa.close();
        for (i = 1; i <= n; i++)
        { iz = A+i; while ((iz = iz->z) != A) f >> iz->x;}
        ofstream fu(u_name, ios::out|ios::binary);
        if (!fu) sp_error_(q1, 8);
        for (a=A,fu.write((char *)a,lmm);a=a->s;fu.write((char *)a,lm));
        ifstream ff(a_name, ios::in|ios::binary);
        if (!ff) sp_error_(q1, 8);
        for (a=A,ff.read((char *)a,lmm);a = a->s;ff.read((char *)a,lm));
      }
      typ |= sp_LDLTinc;
      break;
    default:
      sp_error_(q1, 26);
  }
  if (!(f >> w) || (*w != '}')) sp_error_(q1, 11);
}

void sp_sMatrix::operator>>(char *name)
{ if (*name == '\0') write(cout);
  else{ ofstream f(name); write(f);}
}

void sp_sMatrix::operator<<(char *name)
{ if (*name == '\0') read(cin);
  else{ ifstream f(name); read(f);}
}

void sp_sMatrix::operator<< (const Mat_el &mat)
{ Int j, i;
  Real s;
  NNE *js, *iz, *l;
  i = mat.i, j = mat.j, s = mat.x;

  if (!s) return;

  if (i > j) i = mat.j, j = mat.i;
  if (!l_A) sp_zero_(&A, &l_A);

  js = A+j; while (js->s->i < i) js = js->s;
  if (js->s->i == i) { js->s->x = s; return; }
  iz = A+i, iz->i += 1, (A+j)->j += 1 ;
  while (iz->z->j < j) iz = iz->z;
  l = A->z, A->z = l->z, l->x = s, l->z = iz->z, l->s = js->s,
  l->i = i, l->j = j, js->s = iz->z = l, l_A--;
}

Real sp_sMatrix::operator>> (Mat_el *mat)
{ Int j = mat->j, i = mat->i;
  if (i > j) i = mat->j, j = mat->i;

  NNE *iz = A+i; while ((iz = iz->z)->j < j);
  if (iz->j == j) mat->x = iz->x; else mat->x = 0;
  return mat->x;
}

sp_Vector sp_sMatrix::operator* (sp_Vector &vv) const
{ 
#ifdef sp_test
  static char *q1 = "sp_sMatrix::operator*";
  if (vv.n != n) sp_error_(q1, 6);
#endif
  Int i, ll, k, le = vv.n_A;
  NNE *js, *iz;
  Vec_el *v, b;
  sp_Vector u(n);
  Real s;

  for (i = 1; i <= n; i++)
  { s = 0, js = A+i, k = 0, v = vv.A;
    while ((k < le) && (ll = (js = js->s)->i) <= i)
    { while ((k < le) && (v->i < ll)) k++, v++;
      if (v->i == ll) s += js->x * v->x;
    }
    iz = A+i; while ((iz = iz->z)->j < i);
    while ((k < le) && (ll = (iz = iz->z)->j) <= n)
    { while ((k < le) && (v->i < ll)) k++, v++;
      if (v->i == ll) s += iz->x*v->x, v++;
    }
    if (!s) continue;
    b.i = i, b.x = s, u << b;
  }
  return u;
}

ls_Vector sp_sMatrix::operator* (ls_Vector &v) const
{ 
#ifdef sp_test
  static char *q1 = "sp_sMatrix::operator*";
  if (v.n != n) sp_error_(q1, 6);
#endif
  Int i, ll;
  NNE *iz, *js;
  Real s, *vv = v.A;
  ls_Vector u(n);

  for (i = 1; i <= n; u[i++] = s)
  { s = 0, js = A+i;
    while ((ll = (js = js->s)->i) < i) s += js->x * vv[ll-1];
    iz = A+i; while ((ll = (iz = iz->z)->j) <= n) s += iz->x * vv[ll-1];
  }
  return u;
}

void sp_sMatrix::change_diagonal (Int j, Int k)
{ 
#ifdef sp_test
  static char *q1 = "sp_sMatrix::change_diagonal";
  if (j >= k) sp_error_(q1, 14);
#endif
  Int i, i0, le;
  Real aj = 0, ak = 0;
  sp_Vector vvj(n), vvk(n);
  Vec_el *vj, *vk;
  vvj = get_row(j), vvk = get_row(k);
  delete_row(j);
  delete_row(k);
  for (le = vvj.n_A, vj = vvj.A, i = 0;
      (i < le) &&((i0 = vj[i].i) <= j); i++)
    if (i0 == j) { aj = vj[i].x, vj[i].x = 0; break; }
  for (; (i < le) &&((i0 = vj[i].i) <= k); i++)
    if (i0 == k) { ak = vj[i].x, vj[i].x = 0; break; }
  if (aj) vj[le].x = aj, vj[le].i = k, le++;
  if (ak) vj[le].x = ak, vj[le].i = j, le++;
  vvj.n_A = le, aj = ak = 0;
  for (le = vvk.n_A, vk = vvk.A, i = 0;
      (i < le) && ((i0 = vk[i].i) <= j); i++)
    if (i0 == j) {aj = vk[i].x, vk[i].x = 0; break; }
  for (; (i < le) && ((i0 = vk[i].i) <= k); i++)
    if (i0 == k) {ak = vk[i].x, vk[i].x = 0; break; }
  if (aj) vk[le].x = aj, vk[le].i = k, le++;
  if (ak) vk[le].x = ak, vk[le].i = j, le++;
  vvk.n_A = le;
  put_row(j, vvk), put_row(k, vvj);
}

ls_Vector sp_sMatrix::solve_with_MAT(ls_Vector &x, ls_Vector &b)
{
#ifdef sp_test
  static char *q1 = "sp_sMatrix::solve_with_MAT";
  if (typ&15) sp_error_(q1, 13);
#endif
  ls_Vector p(n), w(n);

  b -= *this * x, p = b;
  Real a, bb = b * b, bbn, wp;
  Int it = 5 * n, jt = it; *rc = 0;

  if (bb < eps) return x;

  while (jt--)
  { w = *this * p, wp = w * p;
    if (fabs(wp) < eps) break;
    a = bb/wp, x += a * p; b -= a * w, bbn = b * b,
    p = b + (bbn/bb) * p, bb = bbn;
  }
  if (bb < eps) { *rc = it-jt; return x; }
  b -= *this * x, p = *this * b, bb = b * b, wp = p * p;
  jt = it;
  while (jt--)
  { a = bb/wp; x += a * p; b -= a * (*this * p), bbn = b * b,
    p = (*this * b) + (bbn/bb) * p, wp = p * p, bb = bbn;
    if (wp < eps) break;
  }
  *rc = it+it-jt;
  return x;
}

ls_Vector sp_sMatrix::solve_with_LDLT(ls_Vector &b)
{ static char *q1 = "sp_sMatrix::solve_with_LDLT";
  Int i, j, k, ll;
  Real s, ss, t;
  NNE *ii, *ij, *ik, *iz, *js, *l;

  if ((typ>>4) != sp_LDLT) sp_error_(q1, 26);

  if (!(typ&15))
  { for (i = 1; i <= n; i++)
    { for (t = 0, ii = A+i; (k = (ii = ii->z)->j) < i;
           t += (A+k)->x * ii->x * ii->x);
      if (ausl (ii->x, t) < eps) sp_error_(q1, 18);
      for((A+i)->x = t = ii->x - t, t = 1/t, ij = ii->z, j=i+1;j<=n;j++)
      { s = ss = 0;
        if (ij->j == j)
        { ss = ij->x, k = ij->i, ij->i = 0;
          js = A+j, js->j -= 1, (A+k)->i -= 1;
          while (js->s->i) js = js->s;
          l = A->z, A->z = ij, ii->z = ij->z, A->z->z = l,
          js->s = js->s->s, ij = ii->z, l_A++;
        }
        ik = A+i;
        while ((k = (ik = ik->z)->j) < i)
        { iz = A+j; while ((ll = (iz = iz->z)-> j) < k);
          if (ll > i) break;
          if (ll == k) s += (A+k)->x * ik->x * iz->x;
        }
        if (ausl(ss, s) < eps) continue;
        s = (ss - s) * t;
        if (!l_A) sp_zero_(&A, &l_A);
        iz = A+j, iz->i += 1; while (iz->z->j < i) iz = iz->z;
        js = A+i, js->j += 1; while (js->s->i < j) js = js->s;
        l = A->z, A->z = A->z->z, l->x = s, l->j = i, l->i = j,
        l->z = iz->z, l->s = js->s, iz->z = js->s = l, l_A--;
      }
    }
    typ |= sp_LDLT;
  }

  if (!b.n) return b;
#ifdef sp_test
  if (b.n != n) sp_error_(q1, 6);
#endif
  ls_Vector x(n);
  Real *xx = x.A, *bb = b.A;

  for (i = 1; i <= n; xx[i-1] = bb[i-1] - s, i++)
    for (s = 0, iz = A+i;(ll = (iz = iz->z)->j)<i;s += iz->x*xx[ll-1]);
  for (j = n; j > 0; xx[j-1] = (xx[j-1]/(A+j)->x) - s, j--)
  { js = A+j; while ((js = js->s)->i < j);
    for ( s = 0; (ll = (js = js->s)->i) <= n; s += js->x * xx[ll-1]);
  }
  return x;
}

ls_Vector sp_sMatrix::solve_with_LDLTpiv(ls_Vector &b)
{ static char *q1 = "sp_sMatrix::solve_with_LDLTpiv";
  Int i, j, k, ll;
  Real s, ss, t;
  NNE *ii, *ij, *ik, *iz, *js, *l;

  if ((typ>>4) != sp_LDLTpiv) sp_error_(q1, 26);

  if (!(typ&15))
  { if (!(icol = new Int[n+1])) sp_error_(q1);
    for (i = 1; i <= n; icol[i] = i, i++);
    for (i = 1; i <= n; i++)
    { for (j = i+1, k = i, ll = (A+i)->j; j <= n; j++)
      if ((A+j)->j < ll) ll = (A+j)->j, k = j;
      if (i < k)
        change_diagonal(i, k),
        ll = icol[i], icol[i]=icol[k], icol[k] = ll;
    }
    for (i = 1; i <= n; i++)
    { for (t = 0, ii = A+i;  (k = (ii = ii->z)->j) < i;
            t += (A+k)->x * ii->x * ii->x);
      if (ausl(ii->x, t) < eps) sp_error_(q1, 18);
      for((A+i)->x = t = ii->x - t, t = 1/t, ij = ii->z, j=i+1;j<=n;j++)
      { s = ss = 0;
        if (ij->j == j)
        { ss = ij->x, k = ij->i, ij->i = 0;
          js = A+j, js->j -= 1, (A+k)->i -= 1;
          while (js->s->i) js = js->s;
          l = A->z, A->z = ij, ii->z = ij->z, A->z->z = l,
          js->s = js->s->s, ij = ii->z, l_A++;
        }
        ik = A+i;
        while (( k= (ik=ik->z)->j) < i)
        { iz = A+j; while ((iz = iz->z)->j < k);
          if (iz->j > i) break;
          if (iz->j == k) s += (A+k)->x * ik->x * iz->x;
        }
        if (ausl(ss, s) < eps) continue;
        s = (ss - s) * t;
        if (!l_A) sp_zero_(&A, &l_A);
        iz = A+j, iz->i += 1; while (iz->z->j < i) iz = iz->z;
        js = A+i, js->j += 1; while (js->s->i < j) js = js->s;
        l = A->z, A->z = A->z->z, l->x = s, l->j = i, l->i = j,
        l->z = iz->z, l->s = js->s, iz->z = js->s = l, l_A--;
      }
    }
    typ |= sp_LDLTpiv;
  }

  if (!b.n) return b;
#ifdef sp_test
  if (b.n != n) sp_error_(q1, 6);
#endif
  ls_Vector x(n);
  Real *xx = x.A, *bb = b.A;

  for (i = 1; i <= n; xx[icol[i]-1] = bb[icol[i]-1]-s, i++)
  { s = 0, iz = A+i;
    while ((ll = (iz = iz->z)->j) < i) s += iz->x * xx[icol[ll]-1];
  }
  for (j = n; j > 0; xx[icol[j]-1] = (xx[icol[j]-1]/(A+j)->x) - s, j--)
  { js = A+j; while((js = js->s)->i <j);
    for (s = 0; (ll = (js = js->s)->i) <= n; s += js->x * xx[icol[ll]-1]);
  }
  return x;
}

ls_Vector sp_sMatrix::solve_with_LDLTinc(ls_Vector &x, ls_Vector &b)
{ static char *q1 = "sp_sMatrix::solve_with_preconditioned_cg";
  Int i, j, k, ll;
  NNE *a, *IZ, *ik, *iz, *ij, *jk, *js;
  Real s, ss, t;
  Int lm = sizeof(NNE)*(More+1), lmm = sizeof(NNE)*(n+1);

  if ((typ>>4) != sp_LDLTinc) sp_error_(q1, 26);

  if (!(typ&15))
  { if (!a_name) a_name = new char [L_tmpnam], tmpnam (a_name);else a_n=1;
    if (!u_name) u_name = new char [L_tmpnam], tmpnam (u_name);else u_n=1;
    { ofstream fa(a_name, ios::out|ios::trunc|ios::binary);
      if (!fa) sp_error_(q1, 8);
      for (a=A,fa.write((char *)a,lmm);a=a->s;fa.write((char *)a,lm));
      fa.close();
    }
    for (i = 1; i <= n; i++)
    { for (t = 0, IZ = A+i;  (k = (IZ = IZ->z)->j) < i;
          t += (A+k)->x * IZ->x * IZ->x);
      if (ausl(IZ->x, t) < eps) sp_error_(q1, 21);
       (A+i)->x = t = IZ->x - t, t = 1/t, ij = IZ;
      while ((j = (ij = ij->z)->j) <= n)
      { s = 0, ss = ij->x, jk = A+j, ik = A+i;
        while ((k = (ik = ik->z)->j) < i)
        { iz = jk; while ((iz = iz->z)->j < k);
          if (iz == A) break;
          if (iz->j == k) s += (A+k)->x * ik->x * iz->x;
        }
        if (ausl(ss, s) < eps) { ij->x = 0; continue; }
        ij->x = (ss - s) * t;
      }
    }
    for (i = 1; i <= n; i++)
      iz = (A+i)->z, (A+i)->z = (A+i)->s, (A+i)->s = iz;
    { ofstream fu(u_name, ios::out|ios::trunc|ios::binary);
      if (!fu) sp_error_(q1, 8);
      for (a=A,fu.write((char *)a,lmm);a=a->s;fu.write((char *)a,lm));
      fu.close();
    }
    { ifstream fa(a_name, ios::in|ios::binary|ios::nocreate);
      if (!fa) sp_error_(q1, 8);
      for (a=A,fa.read((char *)a,lmm);a=a->s;fa.read((char *)a,lm));
      fa.close();
    }
    typ |= sp_LDLTinc;
  }

  if (!b.n) return b;

  ifstream fa(a_name, ios::in|ios::binary|ios::nocreate);
  if (!fa) sp_error_(q1, 8);
  ifstream fu(u_name, ios::in|ios::binary|ios::nocreate);
  if (!fu) sp_error_(q1, 8);
  ls_Vector p(n), q(n), y(n);
  Int it = 5*n, jt = it; *rc = 0;
  Real alpha, bq1, bq2, *bb=b.A, *qq=q.A;
  b -= *this * x;
  for (a=A,fu.read((char *)a,lmm);a=a->s;fu.read((char *)a,lm));
  fu.seekg(0, ios::beg);

// mit U und b auf q loesen

  for (i = 1; i <= n; qq[i-1] = bb[i-1] - s, i++)
    for (s = 0, iz = A+i;(ll = (iz = iz->z)->j)<i;s += iz->x * qq[ll-1]);
  for (i = n; i > 0; qq[i-1] = (qq[i-1]/(A+i)->x)-s, i--)
  { s = 0, js = A+i; while ((js = js->s)->i < i);
    while ((ll = (js = js->s)->i) <= n) s += js->x * qq[ll-1];
  }
  bq1 = b * q, p = q;

  while (jt--)
  { if (fabs(bq1) < eps) break;
    for (a=A,fa.read((char *)a,lmm);a=a->s;fa.read((char *)a,lm));
    fa.seekg(0, ios::beg);
    y = *this * p;
    if (fabs(s = p*y) < eps) break;
    alpha = bq1/s; x += alpha * p; b -= alpha * y;
    for (a=A,fu.read((char *)a,lmm);a=a->s;fu.read((char *)a,lm));
    fu.seekg(0, ios::beg);
    for (i = 1; i <= n; qq[i-1] = bb[i-1] - s, i++)
      for (s = 0, iz = A+i;(ll = (iz = iz->z)->j)<i;s += iz->x * qq[ll-1]);
    for (i = n; i > 0; qq[i-1] = (qq[i-1]/(A+i)->x)-s, i--)
    { s = 0, js = A+i; while ((js = js->s )->i < i);
      while ((ll = (js = js->s)->i) <= n) s += js->x * qq[ll-1];
    }
    bq2 = b * q; p = q + (bq2/bq1) * p; bq1 = bq2;
  }
  *rc = it-jt;
  return x;
}

ls_Vector sp_sMatrix::solve(ls_Vector &b)
{ static char *q1 ="sp_sMatrix::solve";
  ls_Vector x(n);

  switch(typ)
  { case     sp_MAT: return solve_with_MAT(x, b);
    case    sp_LDLT: return solve_with_LDLT(b);
    case sp_LDLTpiv: return solve_with_LDLTpiv(b);
    case sp_LDLTinc: return solve_with_LDLTinc(x, b);
    default: sp_error_(q1, 26);
  }
  return x;
}
